<script setup lang="ts">
import { useUserStore } from "@/stores/users";
import { onBeforeMount, onMounted, reactive } from "vue";
import { RoleEnum, type UserOutExtended } from "@/client/types.gen";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import BootstrapToast from "@/components/BootstrapToast.vue";
import { Toast } from "bootstrap";
import CreateUserModal from "@/components/admin/CreateUserModal.vue";
import DeleteUserModal from "@/components/modals/DeleteUserModal.vue";
import { useRoute, useRouter } from "vue-router";
import dayjs from "dayjs";
import UserDetailModal from "@/components/admin/UserDetailModal.vue";

const userRepository = useUserStore();
const route = useRoute<"admin-users">();
const router = useRouter();
let successInvitationToast: Toast | undefined;

const QUERY_PARAM_ROLE = "role";
const QUERY_PARAM_NAME_SEARCH = "search";

const filters = reactive<{
  searchString: string;
  roles: RoleEnum[];
}>({
  searchString: "",
  roles: [],
});

const userState = reactive<{
  loading: boolean;
  users: UserOutExtended[];
  editedUser?: UserOutExtended;
  errorMessage: string;
  searched: boolean;
  selectedUser?: UserOutExtended;
}>({
  loading: false,
  users: [],
  editedUser: undefined,
  errorMessage: "",
  searched: false,
  selectedUser: undefined,
});

function searchUsers() {
  userState.loading = true;
  userRepository
    .fetchUsers(
      filters.searchString ? filters.searchString : undefined,
      filters.roles ? filters.roles : undefined,
    )
    .then((users) => {
      userState.users = users;
    })
    .finally(() => {
      userState.loading = false;
      userState.searched = true;
    });
  const queryParams: Record<string, string | string[]> = {};
  if (filters.roles.length > 0) {
    queryParams[QUERY_PARAM_ROLE] = filters.roles;
  }
  if (filters.searchString.trim().length > 0) {
    queryParams[QUERY_PARAM_NAME_SEARCH] = filters.searchString;
  }
  router.replace({ name: "admin-users", query: queryParams });
}

function resetForm() {
  filters.searchString = "";
  filters.roles = [];
  userState.users = [];
  userState.searched = false;
  router.replace({ name: "admin-users" });
}

function resendInvitationEmail(uid: string) {
  userState.loading = true;
  userRepository
    .resendInvitationEmail(uid)
    .then(() => {
      successInvitationToast?.show();
    })
    .finally(() => {
      userState.loading = false;
    });
}

function deleteUser(uid: string) {
  userRepository
    .deleteUser(uid)
    .then(() => {
      userState.users = userState.users.filter((user) => user.uid !== uid);
    })
    .finally(() => {
      userState.selectedUser = undefined;
    });
}

function userRolesUpdated(uid: string, roles: RoleEnum[]) {
  const index = userState.users.findIndex((user) => user.uid === uid);
  if (index >= 0) {
    userState.users[index].roles = roles;
  }
}

onMounted(() => {
  successInvitationToast = new Toast("#resend-invitation-success-toast");
});

onBeforeMount(() => {
  let search = false;
  if (route.query[QUERY_PARAM_ROLE] != undefined) {
    if (typeof route.query[QUERY_PARAM_ROLE] === "string") {
      filters.roles = [route.query[QUERY_PARAM_ROLE] as RoleEnum];
    } else {
      filters.roles = route.query[QUERY_PARAM_ROLE].filter(
        (val) => val != undefined,
      ).map((val) => val as RoleEnum);
    }
    search = filters.roles.length > 0 || search;
  }
  if (route.query[QUERY_PARAM_NAME_SEARCH] != undefined) {
    if (typeof route.query[QUERY_PARAM_NAME_SEARCH] === "string") {
      filters.searchString = route.query[QUERY_PARAM_NAME_SEARCH];
      search = true;
    }
  }
  if (search) {
    searchUsers();
  }
});
</script>

<template>
  <bootstrap-toast toast-id="resend-invitation-success-toast">
    Successfully resend invitation email
  </bootstrap-toast>
  <delete-user-modal
    modal-id="delete-user-modal"
    :user="userState.selectedUser ?? { display_name: '', uid: '' }"
    @confirm-delete="deleteUser"
  />
  <user-detail-modal
    modal-id="view-user-details-modal"
    :user="userState.selectedUser"
    @roles-updated="userRolesUpdated"
  />
  <create-user-modal modal-id="create-user-modal" />
  <div
    class="row border-bottom mb-4 justify-content-between align-items-center pb-2 pe-2"
  >
    <h2 class="w-fit">Manage Users</h2>
    <button
      type="button"
      class="btn btn-primary w-fit"
      data-bs-toggle="modal"
      data-bs-target="#create-user-modal"
    >
      Invite User
    </button>
  </div>
  <form
    id="admin-user-search-form"
    @submit.prevent="searchUsers"
    @reset.prevent="resetForm"
  >
    <div
      class="d-flex justify-content-evenly align-content-center column-gap-3 flex-wrap mb-2"
    >
      <div>
        <label for="admin-user-state-select" class="form-label"
          >User Roles</label
        >
        <select
          id="admin-user-state-select"
          v-model="filters.roles"
          multiple
          class="form-select w-fit"
        >
          <option v-for="role in Object.values(RoleEnum)" :key="role">
            {{ role }}
          </option>
        </select>
      </div>
      <div class="flex-fill">
        <label for="admin-user-name-search" class="form-label"
          >Name of a user</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-search" />
          </div>
          <input
            id="admin-user-name-search"
            v-model="filters.searchString"
            type="search"
            class="form-control"
            maxlength="32"
            minlength="3"
            placeholder="Search for user name"
          />
        </div>
      </div>
    </div>
    <button
      type="submit"
      class="btn btn-primary w-fit"
      :disabled="userState.loading"
    >
      Search
    </button>
    <button
      type="reset"
      class="btn btn-primary w-fit ms-4"
      :disabled="userState.loading"
    >
      Reset
    </button>
  </form>
  <div
    v-if="userState.users"
    class="overflow-x-auto flex-grow-1"
    style="max-width: 100vw"
  >
    <table class="table table-striped align-middle caption-top">
      <caption>
        Displaying
        {{
          userState.users.length
        }}
        Users
      </caption>
      <thead>
        <tr>
          <th scope="col"><b>Name</b></th>
          <th scope="col">Email</th>
          <th scope="col">Last Login</th>
          <th scope="col">IdP</th>
          <th scope="col">Roles</th>
          <th scope="col"></th>
        </tr>
      </thead>
      <tbody v-if="userState.users.length === 0">
        <tr>
          <td colspan="6" class="text-center fst-italic fw-light">
            <template v-if="userState.searched"
              >No Users found with specified filters
            </template>
            <template v-else>Select a filter and search for Users</template>
          </td>
        </tr>
      </tbody>
      <tbody v-else>
        <tr v-for="user in userState.users" :key="user.uid">
          <th scope="row">
            <img
              :src="user.gravatar_url + '?d=mp&s=48'"
              class="rounded-circle"
              height="48"
              width="48"
              alt="profile picture"
            />
            <div>{{ user.display_name }}</div>
          </th>
          <td>
            <a v-if="user.email" :href="`mailto:${user.email}`">{{
              user.email
            }}</a>
          </td>
          <td>
            <span v-if="user.last_login">{{
              dayjs.unix(user.last_login).format("MMM DD, YYYY HH:mm")
            }}</span>
          </td>
          <td>
            <div class="form-check">
              <input
                :id="`user-${user.uid}-lifescience-connected`"
                type="checkbox"
                class="form-check-input"
                :checked="user.lifescience_id != undefined"
                disabled
              />
              <label
                class="form-check-label opacity-100"
                :for="`user-${user.uid}-lifescience-connected`"
              >
                LifeScience AAI
              </label>
            </div>
            <div class="form-check">
              <input
                :id="`user-${user.uid}-nfdi-connected`"
                type="checkbox"
                class="form-check-input"
                :checked="user.nfdi_id != undefined"
                disabled
              />
              <label
                class="form-check-label opacity-100"
                :for="`user-${user.uid}-nfdi-connected`"
              >
                NFDI AAI
              </label>
            </div>
          </td>
          <td>
            <div
              v-for="role in Object.values(RoleEnum)"
              :key="role"
              class="form-check"
            >
              <input
                :id="`user-${user.uid}-roles-${role}`"
                type="checkbox"
                class="form-check-input"
                :checked="user.roles.includes(role)"
                disabled
              />
              <label
                class="form-check-label opacity-100 text-uppercase"
                :for="`user-${user.uid}-roles-${role}`"
              >
                {{ role }}
              </label>
            </div>
          </td>
          <td class="text-end">
            <div class="btn-group">
              <button
                type="button"
                class="btn btn-sm btn-secondary"
                data-bs-toggle="modal"
                data-bs-target="#view-user-details-modal"
                @click="userState.selectedUser = user"
              >
                Details
              </button>
              <button
                type="button"
                class="btn btn-secondary btn-sm dropdown-toggle dropdown-toggle-split"
                data-bs-toggle="dropdown"
                aria-expanded="false"
              >
                <span class="visually-hidden">Toggle Dropdown</span>
              </button>
              <ul class="dropdown-menu">
                <li>
                  <a
                    v-if="user.invitation_token_created_at"
                    class="dropdown-item"
                    :class="{ disabled: userState.loading }"
                    :aria-disabled="userState.loading"
                    @click="resendInvitationEmail(user.uid)"
                    >Resend invitation email</a
                  >
                </li>
                <li>
                  <router-link
                    :to="{
                      name: 'admin-buckets',
                      query: { owner_id: user.uid },
                    }"
                    class="dropdown-item"
                    >View Buckets
                  </router-link>
                </li>
                <li>
                  <router-link
                    :to="{
                      name: 'admin-executions',
                      query: { executor_id: user.uid },
                    }"
                    class="dropdown-item"
                    >View Workflow executions
                  </router-link>
                </li>
                <li>
                  <router-link
                    :to="{
                      name: 'admin-tokens',
                      query: { owner_id: user.uid },
                    }"
                    class="dropdown-item"
                    >View API tokens
                  </router-link>
                </li>
                <li
                  v-if="
                    user.roles.includes(RoleEnum.DB_MAINTAINER) ||
                    user.roles.includes(RoleEnum.ADMINISTRATOR)
                  "
                >
                  <router-link
                    :to="{
                      name: 'admin-resources',
                      query: { maintainer_id: user.uid },
                    }"
                    class="dropdown-item"
                    >View Resources
                  </router-link>
                </li>
                <li v-if="user.uid !== userRepository.currentUID">
                  <button
                    type="button"
                    class="dropdown-item text-danger align-middle"
                    data-bs-toggle="modal"
                    data-bs-target="#delete-user-modal"
                    @click="userState.selectedUser = user"
                  >
                    <font-awesome-icon icon="fa-solid fa-trash" class="me-1" />
                    Delete
                  </button>
                </li>
              </ul>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<style scoped></style>
